--- old/usr/src/cmd/localedef/messages.c	Tue May 20 07:58:43 2014
+++ new/usr/src/cmd/localedef/messages.c	Tue May 20 07:58:43 2014
@@ -10,6 +10,7 @@
  */
 
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  */
 
@@ -28,7 +29,7 @@
 #include "parser.tab.h"
 #include "lmessages.h"
 
-static struct lc_messages_T msgs;
+static struct lc_messages msgs;
 
 void
 init_messages(void)
--- old/usr/src/cmd/localedef/monetary.c	Tue May 20 07:58:43 2014
+++ new/usr/src/cmd/localedef/monetary.c	Tue May 20 07:58:43 2014
@@ -10,6 +10,7 @@
  */
 
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  */
 
@@ -27,7 +28,7 @@
 #include "parser.tab.h"
 #include "lmonetary.h"
 
-static struct lc_monetary_T mon;
+static struct lc_monetary mon;
 
 void
 init_monetary(void)
--- old/usr/src/cmd/localedef/numeric.c	Tue May 20 07:58:44 2014
+++ new/usr/src/cmd/localedef/numeric.c	Tue May 20 07:58:44 2014
@@ -10,6 +10,7 @@
  */
 
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  */
 
@@ -27,7 +28,7 @@
 #include "parser.tab.h"
 #include "lnumeric.h"
 
-static struct lc_numeric_T numeric;
+static struct lc_numeric numeric;
 
 void
 init_numeric(void)
--- old/usr/src/cmd/localedef/time.c	Tue May 20 07:58:44 2014
+++ new/usr/src/cmd/localedef/time.c	Tue May 20 07:58:44 2014
@@ -10,6 +10,7 @@
  */
 
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  */
 
@@ -27,7 +28,7 @@
 #include "parser.tab.h"
 #include "timelocal.h"
 
-struct lc_time_T tm;
+struct lc_time tm;
 
 void
 init_time(void)
--- old/usr/src/cmd/mdb/common/kmdb/mapfile_skel	Tue May 20 07:58:44 2014
+++ new/usr/src/cmd/mdb/common/kmdb/mapfile_skel	Tue May 20 07:58:44 2014
@@ -44,10 +44,19 @@
 		 * Secret additions to the module API
 		 */
 
-		/* Implementation detail of the ctype macros */
-		__ctype;	/* variable */
 		/* There should be only one - ours */
 		errno;		/* variable */
+		isprint;
+		isalnum;
+		isalpha;
+		isgraph;
+		iscntrl;
+		isdigit;
+		isxdigit;
+		isupper;
+		islower;
+		ispunct;
+		isspace;
 
 		mdb_tgt_aread;
 		mdb_dis_create;
--- old/usr/src/cmd/mdb/common/libstand/ctype.c	Tue May 20 07:58:44 2014
+++ new/usr/src/cmd/mdb/common/libstand/ctype.c	Tue May 20 07:58:44 2014
@@ -1,50 +1,97 @@
 /*
- * CDDL HEADER START
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
  *
- * The contents of this file are subject to the terms of the
- * Common Development and Distribution License, Version 1.0 only
- * (the "License").  You may not use this file except in compliance
- * with the License.
- *
- * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
- * or http://www.opensolaris.org/os/licensing.
- * See the License for the specific language governing permissions
- * and limitations under the License.
- *
- * When distributing Covered Code, include this CDDL HEADER in each
- * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
- * If applicable, add the following below this CDDL HEADER, with the
- * fields enclosed by brackets "[]" replaced with your own identifying
- * information: Portions Copyright [yyyy] [name of copyright owner]
- *
- * CDDL HEADER END
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
  */
+
 /*
- * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
- * Use is subject to license terms.
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
+/*
+ * ASCII versions of ctype character classification functions.  This avoids
+ * pulling in the entire locale framework that is in libc.
+ */
 
-#include <ctype.h>
+int
+isdigit(int c)
+{
+	return ((c >= '0' && c <= '9') ? 1 : 0);
+}
 
-unsigned char __ctype[129] =
+int
+isupper(int c)
 {
-	0, /* EOF */
-	_C,	_C,	_C,	_C,	_C,	_C,	_C,	_C,
-	_C,	_S|_C,	_S|_C,	_S|_C,	_S|_C,	_S|_C,	_C,	_C,
-	_C,	_C,	_C,	_C,	_C,	_C,	_C,	_C,
-	_C,	_C,	_C,	_C,	_C,	_C,	_C,	_C,
-	_S|_B,	_P,	_P,	_P,	_P,	_P,	_P,	_P,
-	_P,	_P,	_P,	_P,	_P,	_P,	_P,	_P,
-	_N|_X,	_N|_X,	_N|_X,	_N|_X,	_N|_X,	_N|_X,	_N|_X,	_N|_X,
-	_N|_X,	_N|_X,	_P,	_P,	_P,	_P,	_P,	_P,
-	_P,	_U|_X,	_U|_X,	_U|_X,	_U|_X,	_U|_X,	_U|_X,	_U,
-	_U,	_U,	_U,	_U,	_U,	_U,	_U,	_U,
-	_U,	_U,	_U,	_U,	_U,	_U,	_U,	_U,
-	_U,	_U,	_U,	_P,	_P,	_P,	_P,	_P,
-	_P,	_L|_X,	_L|_X,	_L|_X,	_L|_X,	_L|_X,	_L|_X,	_L,
-	_L,	_L,	_L,	_L,	_L,	_L,	_L,	_L,
-	_L,	_L,	_L,	_L,	_L,	_L,	_L,	_L,
-	_L,	_L,	_L,	_P,	_P,	_P,	_P,	_C,
-};
+	return ((c >= 'A' && c <= 'Z') ? 1 : 0);
+}
+
+
+int
+islower(int c)
+{
+	return ((c >= 'a' && c <= 'z') ? 1 : 0);
+}
+
+int
+isspace(int c)
+{
+	return (((c == ' ') || (c == '\t') || (c == '\r') || (c == '\n') ||
+	    (c == '\v') || (c == '\f')) ? 1 : 0);
+}
+
+int
+isxdigit(int c)
+{
+	return ((isdigit(c) || (c >= 'A' && c <= 'F') ||
+	    (c >= 'a' && c <= 'f')) ? 1 : 0);
+}
+
+int
+isalpha(int c)
+{
+	return ((isupper(c) || islower(c)) ? 1 : 0);
+}
+
+
+int
+isalnum(int c)
+{
+	return ((isalpha(c) || isdigit(c)) ? 1 : 0);
+}
+
+int
+ispunct(int c)
+{
+	return (((c >= '!') && (c <= '/')) ||
+	    ((c >= ':') && (c <= '@')) ||
+	    ((c >= '[') && (c <= '`')) ||
+	    ((c >= '{') && (c <= '~')));
+}
+
+int
+iscntrl(int c)
+{
+	return ((c < 0x20) || (c == 0x7f));
+}
+
+int
+isprint(int c)
+{
+	/*
+	 * Almost the inverse of iscntrl, but be careful that c > 0x7f
+	 * returns false for everything.
+	 */
+	return ((c >= ' ') && (c <= '~'));
+}
+
+int
+isgraph(int c)
+{
+	/* isgraph is like is print, but excludes <space> */
+	return ((c >= '!') && (c <= '~'));
+}
--- old/usr/src/cmd/sgs/rtld/common/external.c	Tue May 20 07:58:44 2014
+++ new/usr/src/cmd/sgs/rtld/common/external.c	Tue May 20 07:58:44 2014
@@ -668,3 +668,52 @@
 	extern ssize_t __write(int, const void *, size_t);
 	return (__write(fd, buf, size));
 }
+
+/*
+ * ASCII versions of ctype character classification functions.  This avoids
+ * pulling in the entire locale framework that is in libc.
+ */
+
+int
+isdigit(int c)
+{
+	return ((c >= '0' && c <= '9') ? 1 : 0);
+}
+
+int
+isupper(int c)
+{
+	return ((c >= 'A' && c <= 'Z') ? 1 : 0);
+}
+
+int
+islower(int c)
+{
+	return ((c >= 'a' && c <= 'z') ? 1 : 0);
+}
+
+int
+isspace(int c)
+{
+	return (((c == ' ') || (c == '\t') || (c == '\r') || (c == '\n') ||
+	    (c == '\v') || (c == '\f')) ? 1 : 0);
+}
+
+int
+isxdigit(int c)
+{
+	return ((isdigit(c) || (c >= 'A' && c <= 'F') ||
+	    (c >= 'a' && c <= 'f')) ? 1 : 0);
+}
+
+int
+isalpha(int c)
+{
+	return ((isupper(c) || islower(c)) ? 1 : 0);
+}
+
+int
+isalnum(int c)
+{
+	return ((isalpha(c) || isdigit(c)) ? 1 : 0);
+}
--- old/usr/src/head/Makefile	Tue May 20 07:58:44 2014
+++ new/usr/src/head/Makefile	Tue May 20 07:58:44 2014
@@ -22,6 +22,8 @@
 # Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
+# Copyright 2013 Garrett D'Amore <garrett@damore.org>
+#
 # head/Makefile
 #
 # include global definitions
@@ -203,12 +205,12 @@
 	wctype.h	\
 	widec.h		\
 	wordexp.h	\
+	xlocale.h	\
 	xti.h		\
 	xti_inet.h	\
 	zone.h
 
 ISOHDRS = \
-	ctype_c99.h	\
 	ctype_iso.h	\
 	limits_iso.h	\
 	locale_iso.h	\
@@ -225,7 +227,6 @@
 	time_iso.h	\
 	wchar_c99.h	\
 	wchar_iso.h	\
-	wctype_c99.h	\
 	wctype_iso.h
 
 ARPAHDRS = 		\
--- old/usr/src/head/ctype.h	Tue May 20 07:58:44 2014
+++ new/usr/src/head/ctype.h	Tue May 20 07:58:44 2014
@@ -27,14 +27,14 @@
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
 
 #ifndef _CTYPE_H
 #define	_CTYPE_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <iso/ctype_iso.h>
-#include <iso/ctype_c99.h>
 
 /*
  * Allow global visibility for symbols defined in
@@ -54,7 +54,10 @@
 using std::isxdigit;
 using std::tolower;
 using std::toupper;
+#if _cplusplus >= 201103L
+using std::isblank;
 #endif
+#endif
 
 #ifdef	__cplusplus
 extern "C" {
@@ -80,25 +83,42 @@
 	defined(_XOPEN_SOURCE)) || defined(__XPG4_CHAR_CLASS__)
 #define	isascii(c)	(!(((int)(c)) & ~0177))
 #define	toascii(c)	(((int)(c)) & 0177)
-#if defined(__XPG4_CHAR_CLASS__) || defined(_XPG4)
-#define	_toupper(c)	(__trans_upper[(int)(c)])
-#define	_tolower(c)	(__trans_lower[(int)(c)])
-#else
-#define	_toupper(c)	((__ctype + 258)[(int)(c)])
-#define	_tolower(c)	((__ctype + 258)[(int)(c)])
-#endif /* defined(__XPG4_CHAR_CLASS__) || defined(_XPG4) */
+#define	_toupper(c)	(toupper(c))
+#define	_tolower(c)	(tolower(c))
 
 #endif /* defined(__EXTENSIONS__) || ((!defined(_STRICT_STDC) ... */
 
 #endif	/* !defined(__lint) */
 
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+
+#ifndef _LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+extern int isalnum_l(int, locale_t);
+extern int isalpha_l(int, locale_t);
+extern int isblank_l(int, locale_t);
+extern int iscntrl_l(int, locale_t);
+extern int isdigit_l(int, locale_t);
+extern int isgraph_l(int, locale_t);
+extern int islower_l(int, locale_t);
+extern int isprint_l(int, locale_t);
+extern int ispunct_l(int, locale_t);
+extern int isspace_l(int, locale_t);
+extern int isupper_l(int, locale_t);
+extern int isxdigit_l(int, locale_t);
+
+#endif /* defined(_XPG7) || !defined(_STRICT_SYMBOLS) */
+
 #else	/* defined(__STDC__) */
 
 #if !defined(__lint)
 
 #define	isascii(c)	(!(((int)(c)) & ~0177))
-#define	_toupper(c)	((_ctype + 258)[(int)(c)])
-#define	_tolower(c)	((_ctype + 258)[(int)(c)])
+#define	_toupper(c)	(isascii(c) ? __trans_upper[(int)(c)] : toupper(c))
+#define	_tolower(c)	(isascii(c) ? __trans_lower[(int)(c)] : tolower(c))
 #define	toascii(c)	(((int)(c)) & 0177)
 
 #endif	/* !defined(__lint) */
--- old/usr/src/head/iso/ctype_iso.h	Tue May 20 07:58:44 2014
+++ new/usr/src/head/iso/ctype_iso.h	Tue May 20 07:58:44 2014
@@ -27,6 +27,9 @@
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
 
 /*
  * An application should not include this header directly.  Instead it
@@ -43,8 +46,6 @@
 #ifndef _ISO_CTYPE_ISO_H
 #define	_ISO_CTYPE_ISO_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/feature_tests.h>
 
 #ifdef	__cplusplus
@@ -73,11 +74,24 @@
 #define	_ISPRINT	0x00008000
 #define	_ISALNUM	(_ISALPHA | _ISDIGIT)
 
+extern unsigned char	__ctype[];
+extern unsigned int	*__ctype_mask;
+extern int		*__trans_upper;
+extern int		*__trans_lower;
 
 #if defined(__STDC__)
 
-#if __cplusplus < 199711L  /* Use inline functions instead for ANSI C++ */
+#if __cplusplus >= 199711L
+namespace std {
+#endif
 
+/*
+ * These used to be macros, which while more efficient, precludes operation
+ * with thread specific locales.  The old macros will still work, but new
+ * code compiles to use functions.  This is specifically permitted by the
+ * various standards.  Only _tolower and _toupper were required to be
+ * delivered in macro form.
+ */
 extern int isalnum(int);
 extern int isalpha(int);
 extern int iscntrl(int);
@@ -89,11 +103,8 @@
 extern int isspace(int);
 extern int isupper(int);
 extern int isxdigit(int);
-
-#endif /* __cplusplus < 199711L */
-
-#if __cplusplus >= 199711L
-namespace std {
+#if defined(_XPG6) || defined(_STDC_C99) || !defined(_STRICT_SYMBOLS)
+extern int isblank(int);
 #endif
 
 extern int tolower(int);
@@ -103,96 +114,22 @@
 } /* end of namespace std */
 #endif
 
-extern unsigned char	__ctype[];
-extern unsigned int	*__ctype_mask;
-extern int		*__trans_upper;
-extern int		*__trans_lower;
-
-#if !defined(__lint)
-
-#if __cplusplus >= 199711L
-namespace std {
-
-#if defined(__XPG4_CHAR_CLASS__) || defined(_XPG4)
-
-inline int isalpha(int c) { return (__ctype_mask[c] & _ISALPHA); }
-inline int isupper(int c) { return (__ctype_mask[c] & _ISUPPER); }
-inline int islower(int c) { return (__ctype_mask[c] & _ISLOWER); }
-inline int isdigit(int c) { return (__ctype_mask[c] & _ISDIGIT); }
-inline int isxdigit(int c) { return (__ctype_mask[c] & _ISXDIGIT); }
-inline int isalnum(int c) { return (__ctype_mask[c] & _ISALNUM); }
-inline int isspace(int c) { return (__ctype_mask[c] & _ISSPACE); }
-inline int ispunct(int c) { return (__ctype_mask[c] & _ISPUNCT); }
-inline int isprint(int c) { return (__ctype_mask[c] & _ISPRINT); }
-inline int isgraph(int c) { return (__ctype_mask[c] & _ISGRAPH); }
-inline int iscntrl(int c) { return (__ctype_mask[c] & _ISCNTRL); }
-#else
-inline int isalpha(int c) { return ((__ctype + 1)[c] & (_U | _L)); }
-inline int isupper(int c) { return ((__ctype + 1)[c] & _U); }
-inline int islower(int c) { return ((__ctype + 1)[c] & _L); }
-inline int isdigit(int c) { return ((__ctype + 1)[c] & _N); }
-inline int isxdigit(int c) { return ((__ctype + 1)[c] & _X); }
-inline int isalnum(int c) { return ((__ctype + 1)[c] & (_U | _L | _N)); }
-inline int isspace(int c) { return ((__ctype + 1)[c] & _S); }
-inline int ispunct(int c) { return ((__ctype + 1)[c] & _P); }
-inline int isprint(int c) {
-	return ((__ctype + 1)[c] & (_P | _U | _L | _N | _B)); }
-inline int isgraph(int c) { return ((__ctype + 1)[c] & (_P | _U | _L | _N)); }
-inline int iscntrl(int c) { return ((__ctype + 1)[c] & _C); }
-#endif  /* defined(__XPG4_CHAR_CLASS__) || defined(_XPG4) */
-
-} /* end of namespace std */
-
-#else /* __cplusplus >= 199711L */
-
-#if defined(__XPG4_CHAR_CLASS__) || defined(_XPG4)
-#define	isalpha(c)	(__ctype_mask[(int)(c)] & _ISALPHA)
-#define	isupper(c)	(__ctype_mask[(int)(c)] & _ISUPPER)
-#define	islower(c)	(__ctype_mask[(int)(c)] & _ISLOWER)
-#define	isdigit(c)	(__ctype_mask[(int)(c)] & _ISDIGIT)
-#define	isxdigit(c)	(__ctype_mask[(int)(c)] & _ISXDIGIT)
-#define	isalnum(c)	(__ctype_mask[(int)(c)] & _ISALNUM)
-#define	isspace(c)	(__ctype_mask[(int)(c)] & _ISSPACE)
-#define	ispunct(c)	(__ctype_mask[(int)(c)] & _ISPUNCT)
-#define	isprint(c)	(__ctype_mask[(int)(c)] & _ISPRINT)
-#define	isgraph(c)	(__ctype_mask[(int)(c)] & _ISGRAPH)
-#define	iscntrl(c)	(__ctype_mask[(int)(c)] & _ISCNTRL)
-#else
-#define	isalpha(c)	((__ctype + 1)[(int)(c)] & (_U | _L))
-#define	isupper(c)	((__ctype + 1)[(int)(c)] & _U)
-#define	islower(c)	((__ctype + 1)[(int)(c)] & _L)
-#define	isdigit(c)	((__ctype + 1)[(int)(c)] & _N)
-#define	isxdigit(c)	((__ctype + 1)[(int)(c)] & _X)
-#define	isalnum(c)	((__ctype + 1)[(int)(c)] & (_U | _L | _N))
-#define	isspace(c)	((__ctype + 1)[(int)(c)] & _S)
-#define	ispunct(c)	((__ctype + 1)[(int)(c)] & _P)
-#define	isprint(c)	((__ctype + 1)[(int)(c)] & (_P | _U | _L | _N | _B))
-#define	isgraph(c)	((__ctype + 1)[(int)(c)] & (_P | _U | _L | _N))
-#define	iscntrl(c)	((__ctype + 1)[(int)(c)] & _C)
-
-#endif  /* defined(__XPG4_CHAR_CLASS__) || defined(_XPG4) */
-
-#endif	/* __cplusplus >= 199711L */
-
-#endif	/* !defined(__lint) */
-
 #else	/* defined(__STDC__) */
 
-extern unsigned char	_ctype[];
-
 #if !defined(__lint)
 
-#define	isalpha(c)	((_ctype + 1)[(int)(c)] & (_U | _L))
-#define	isupper(c)	((_ctype + 1)[(int)(c)] & _U)
-#define	islower(c)	((_ctype + 1)[(int)(c)] & _L)
-#define	isdigit(c)	((_ctype + 1)[(int)(c)] & _N)
-#define	isxdigit(c)	((_ctype + 1)[(int)(c)] & _X)
-#define	isalnum(c)	((_ctype + 1)[(int)(c)] & (_U | _L | _N))
-#define	isspace(c)	((_ctype + 1)[(int)(c)] & _S)
-#define	ispunct(c)	((_ctype + 1)[(int)(c)] & _P)
-#define	isprint(c)	((_ctype + 1)[(int)(c)] & (_P | _U | _L | _N | _B))
-#define	isgraph(c)	((_ctype + 1)[(int)(c)] & (_P | _U | _L | _N))
-#define	iscntrl(c)	((_ctype + 1)[(int)(c)] & _C)
+extern int isalpha();
+extern int isupper();
+extern int islower();
+extern int isdigit();
+extern int isxdigit();
+extern int isalnum();
+extern int isspace();
+extern int ispunct();
+extern int isprint();
+extern int isgraph();
+extern int iscntrl();
+extern int isblank();
 
 #endif	/* !defined(__lint) */
 
--- old/usr/src/head/iso/stdlib_iso.h	Tue May 20 07:58:44 2014
+++ new/usr/src/head/iso/stdlib_iso.h	Tue May 20 07:58:44 2014
@@ -23,6 +23,9 @@
  * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
 
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved  	*/
@@ -50,12 +53,13 @@
 #endif
 
 #if defined(__STDC__)
-extern unsigned char	__ctype[];
-#define	MB_CUR_MAX	__ctype[520]
+unsigned char __mb_cur_max(void);
 #else
-extern unsigned char	_ctype[];
-#define	MB_CUR_MAX	_ctype[520]
+unsigned char __mb_cur_max();
 #endif
+#ifndef MB_CUR_MAX
+#define	MB_CUR_MAX	(__mb_cur_max())
+#endif
 
 #if __cplusplus >= 199711L
 namespace std {
--- old/usr/src/head/iso/wctype_iso.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/iso/wctype_iso.h	Tue May 20 07:58:45 2014
@@ -27,6 +27,9 @@
  * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
 
 /*
  * An application should not include this header directly.  Instead it
@@ -43,8 +46,6 @@
 #ifndef	_ISO_WCTYPE_ISO_H
 #define	_ISO_WCTYPE_ISO_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/feature_tests.h>
 
 #ifdef	__cplusplus
@@ -94,6 +95,12 @@
 extern	int iswspace(wint_t);
 extern	int iswupper(wint_t);
 extern	int iswxdigit(wint_t);
+
+#if (__cplusplus >= 201103L) || defined(_STDC_C99) || defined(_XPG6) || \
+	!defined(_STRICT_SYMBOLS)
+extern	int iswblank(wint_t);
+#endif
+
 /* tow* also become functions */
 extern	wint_t towlower(wint_t);
 extern	wint_t towupper(wint_t);
@@ -101,7 +108,7 @@
 extern	wint_t towctrans(wint_t, wctrans_t);
 extern  int iswctype(wint_t, wctype_t);
 extern  wctype_t wctype(const char *);
-#else
+#else	/* __STDC__ */
 extern  int iswalnum();
 extern  int iswalpha();
 extern  int iswcntrl();
@@ -120,7 +127,10 @@
 extern	wint_t towctrans();
 extern  int iswctype();
 extern  wctype_t wctype();
+#if defined(_XPG6) || !defined(_STRICT_SYMBOLS)
+extern  int iswblank();
 #endif
+#endif	/* __STDC__ */
 
 /* bit definition for character class */
 
--- old/usr/src/head/langinfo.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/langinfo.h	Tue May 20 07:58:45 2014
@@ -27,12 +27,14 @@
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved  	*/
 
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
 
+
 #ifndef	_LANGINFO_H
 #define	_LANGINFO_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"	/* SVr4.0 1.2	*/
-
 #include <sys/feature_tests.h>
 #include <nl_types.h>
 
@@ -150,6 +152,19 @@
 char   *nl_langinfo();		/* get a string from the database	*/
 #endif
 
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+#ifndef	_LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+#if defined(__STDC__)
+char	*nl_langinfo_l(nl_item, locale_t);
+#else
+char	*nl_langinfo_l();
+#endif
+#endif
+
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/head/locale.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/locale.h	Tue May 20 07:58:45 2014
@@ -24,11 +24,20 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ *
+ * Portions of this file developed by Garrett D'Amore are licensed
+ * under the terms of the Common Development and Distribution License (CDDL)
+ * version 1.0 only.  The use of subsequent versions of the License are
+ * is specifically prohibited unless those terms are not in conflict with
+ * version 1.0 of the License.  You can find this license on-line at
+ * http://www.illumos.org/license/CDDL
+ */
+
 #ifndef _LOCALE_H
 #define	_LOCALE_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <iso/locale_iso.h>
 
 #if (!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX)) || \
@@ -56,6 +65,42 @@
 	(((int)(c) >= LC_CTYPE) && ((int)(c) <= _LastCategory) || \
 	((int)c == LC_ALL))
 
+
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+
+/*
+ * These were added in POSIX 2008 as part of the newlocale() specification.
+ */
+#define	LC_CTYPE_MASK		(1 << LC_CTYPE)
+#define	LC_NUMERIC_MASK		(1 << LC_NUMERIC)
+#define	LC_TIME_MASK		(1 << LC_TIME)
+#define	LC_COLLATE_MASK		(1 << LC_COLLATE)
+#define	LC_MONETARY_MASK	(1 << LC_MONETARY)
+#define	LC_MESSAGES_MASK	(1 << LC_MESSAGES)
+#define	LC_ALL_MASK		(0x3f)
+
+#ifndef _LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+#if	defined(__STDC__)
+locale_t	duplocale(locale_t);
+void		freelocale(locale_t);
+locale_t	newlocale(int, const char *, locale_t);
+locale_t	uselocale(locale_t);
+#else	/* __STDC__ */
+locale_t	duplocale();
+void		freelocale();
+locale_t	newlocale();
+locale_t	uselocale();
+#endif	/* __STDC__ */
+
+#define	LC_GLOBAL_LOCALE	__global_locale
+extern locale_t			__global_locale;
+
+#endif	/* defined(_XPG7) || !defined(_STRICT_SYMBOLS) */
+
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/head/monetary.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/monetary.h	Tue May 20 07:58:45 2014
@@ -23,12 +23,13 @@
  * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
 
 #ifndef	_MONETARY_H
 #define	_MONETARY_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/feature_tests.h>
 #include <sys/types.h>
 
@@ -39,8 +40,21 @@
 #if defined(__STDC__)
 extern ssize_t	strfmon(char *_RESTRICT_KYWD, size_t,
 			const char *_RESTRICT_KYWD, ...);
+
+#if defined(_XPG7) || (!defined(_STRICT_STRICT_SYMBOLS))
+
+#ifndef _LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+extern ssize_t strfmon_l(char *_RESTRICT_KYWD, size_t, locale_t,
+		const char *_RESTRICT_KYWD, ...);
+#endif
+
 #else
 extern ssize_t	strfmon();
+extern ssize_t	strfmon_l();
 #endif
 
 #ifdef __cplusplus
--- old/usr/src/head/string.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/string.h	Tue May 20 07:58:45 2014
@@ -20,6 +20,7 @@
  */
 
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
@@ -86,20 +87,30 @@
 		int, size_t);
 #endif
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
-extern int strcasecmp(const char *, const char *);
-extern int strncasecmp(const char *, const char *, size_t);
+#if !defined(_STRICT_SYMBOLS) || defined(_XPG7)
+
 extern char *stpcpy(char *_RESTRICT_KYWD, const char *_RESTRICT_KYWD);
 extern char *stpncpy(char *_RESTRICT_KYWD, const char *_RESTRICT_KYWD, size_t);
 extern char *strndup(const char *, size_t);
 extern size_t strnlen(const char *, size_t);
 extern char *strsignal(int);
+
+#ifndef	_LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
 #endif
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
+extern int strcoll_l(const char *, const char *, locale_t);
+extern size_t strxfrm_l(char *_RESTRICT_KYWD, const char *_RESTRICT_KYWD,
+    size_t, locale_t);
+extern int strcasecmp_l(const char *, const char *, locale_t);
+extern int strncasecmp_l(const char *, const char *, size_t, locale_t);
+
+#endif /* defined(_STRICT_SYMBOLS) || defined(_XPG7) */
+
+#if !defined(_STRICT_SYMBOLS)
+
+/* Note that some of these are also declared in strings.h for XPG4_2+ */
 extern int uucopy(const void *_RESTRICT_KYWD, void *_RESTRICT_KYWD, size_t);
 extern int uucopystr(const void *_RESTRICT_KYWD, void *_RESTRICT_KYWD, size_t);
 extern int ffs(int);
@@ -115,6 +126,9 @@
 extern size_t strlcat(char *, const char *, size_t);
 extern char *strsep(char **stringp, const char *delim);
 extern char *strchrnul(const char *, int);
+extern char *strcasestr_l(const char *, const char *, locale_t);
+extern int strcasecmp(const char *, const char *);
+extern int strncasecmp(const char *, const char *, size_t);
 #endif /* defined(__EXTENSIONS__)... */
 
 #if defined(__EXTENSIONS__) || \
@@ -194,11 +208,11 @@
 extern void *memccpy();
 #endif
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
 extern int strcasecmp();
 extern int strncasecmp();
+extern int strcasecmp_l();
+extern int strncasecmp_l();
 extern char *stpcpy();
 extern char *stpncpy();
 extern char *strndup();
@@ -206,8 +220,7 @@
 extern char *strsignal();
 #endif
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
+#if !defined(_STRICT_SYMBOLS)
 extern int uucopy();
 extern int uucopystr();
 extern int ffs();
@@ -217,17 +230,23 @@
 extern int flsl();
 extern int flsll();
 extern char *strcasestr();
+extern char *strcasestr_l();
 extern char *strnstr();
 extern size_t strlcpy();
 extern size_t strlcat();
 extern char *strsep();
 extern char *strchrnul();
-#endif /* defined(__EXTENSIONS__) ... */
+#endif /* _STRICT_SYMBOLS */
 
 #if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || defined(_XPG4_2)
 extern char *strdup();
 #endif
 
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+extern size_t strcoll_l();
+extern size_t strxfrm_l();
+#endif
+
 #endif	/* __STDC__ */
 
 #ifdef	__cplusplus
--- old/usr/src/head/strings.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/strings.h	Tue May 20 07:58:45 2014
@@ -23,12 +23,13 @@
  * Copyright (c) 1995, 1996, by Sun Microsystems, Inc.
  * All rights reserved.
  */
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
 
 #ifndef	_STRINGS_H
 #define	_STRINGS_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <sys/feature_tests.h>
 
@@ -63,6 +64,14 @@
 extern int ffs(int);
 extern int strcasecmp(const char *, const char *);
 extern int strncasecmp(const char *, const char *, size_t);
+#if defined(_XPG7)
+#ifndef	_LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+extern int strcasecmp_l(const char *, const char *, locale_t);
+extern int strncasecmp_l(const char *, const char *, size_t, locale_t);
+#endif	/* defined(_XPG7) */
 #endif	/* defined(_XPG4_2) && !defined(__EXTENSIONS__) */
 
 #else
@@ -78,6 +87,10 @@
 extern int ffs();
 extern int strcasecmp();
 extern int strncasecmp();
+#if defined(_XPG7)
+extern int strcasecmp_l();
+extern int strncasecmp_l();
+#endif
 #endif /* defined(_XPG4_2) && !defined(__EXTENSIONS__) */
 
 #endif	/* __STDC__ */
--- old/usr/src/head/time.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/time.h	Tue May 20 07:58:45 2014
@@ -28,6 +28,7 @@
  */
 /*
  * Copyright 2010 Nexenta Systems, Inc.  Al rights reserved.
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 #ifndef _TIME_H
@@ -371,6 +372,23 @@
 
 #endif /* defined(__EXTENSIONS__) || defined(_REENTRANT)... */
 
+
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+
+#ifndef	_LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+#if	defined(__STDC__)
+extern size_t strftime_l(char *_RESTRICT_KYWD, size_t,
+	const char *_RESTRICT_KYWD, const struct tm *_RESTRICT_KYWD, locale_t);
+#else /* __STDC__ */
+extern size_t strftime_l();
+#endif /* __STDC__ */
+
+#endif /* defined(_XPG7) || !defined(_STRICT_SYMBOLS) */
+
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/head/wchar.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/wchar.h	Tue May 20 07:58:45 2014
@@ -20,6 +20,7 @@
  */
 
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 1993, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
@@ -167,18 +168,30 @@
 #endif
 #endif /* !defined(_STRICT_STDC) || defined(_XOPEN_SOURCE)... */
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
-extern wchar_t *wcsdup(const wchar_t *);
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+
+#ifndef _LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
 extern size_t wcsnlen(const wchar_t *, size_t);
 extern wchar_t *wcpcpy(wchar_t *_RESTRICT_KYWD, const wchar_t *_RESTRICT_KYWD);
 extern wchar_t *wcpncpy(wchar_t *_RESTRICT_KYWD, const wchar_t *_RESTRICT_KYWD,
     size_t);
+extern size_t wcsxfrm_l(wchar_t *_RESTRICT_KYWD, const wchar_t *_RESTRICT_KYWD,
+    size_t, locale_t);
+extern int wcscoll_l(const wchar_t *, const wchar_t *, locale_t);
+extern wchar_t *wcsdup(const wchar_t *);
 extern int wcscasecmp(const wchar_t *, const wchar_t *);
+extern int wcscasecmp_l(const wchar_t *, const wchar_t *, locale_t);
 extern int wcsncasecmp(const wchar_t *, const wchar_t *, size_t);
-#endif
+extern int wcsncasecmp_l(const wchar_t *, const wchar_t *, size_t, locale_t);
+extern size_t mbsnrtowcs(wchar_t *_RESTRICT_KYWD, const char **_RESTRICT_KYWD,
+    size_t, size_t, mbstate_t *_RESTRICT_KYWD);
 
+#endif	/* defined(_XPG7) || !defined(_STRICT_SYMBOLS) */
+
 #else /* __STDC__ */
 
 #if !defined(_STRICT_STDC) || defined(_XOPEN_SOURCE) || defined(__EXTENSIONS__)
@@ -202,15 +215,18 @@
 extern wctype_t wctype();
 #endif /* !defined(_STRICT_STDC) || defined(_XOPEN_SOURCE)... */
 
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
-	/* || defined(_XPG7) */
-extern wchar_t *wcsdup();
+#if defined(_XGP7) || !defined(_STRICT_SYMBOLS)
 extern size_t wcsnlen();
 extern wchar_t *wcpcpy();
 extern wchar_t *wcpncpy();
+extern size_t wcsxfrm_l();
+extern int wcscoll_l();
+extern wchar_t *wcsdup();
 extern int wcscasecmp();
+extern int wcscasecmp_l();
 extern int wcsncasecmp();
+extern int wcsncasecmp_l();
+extern size_t mbsnrtowcs();
 #endif
 
 #endif /* __STDC__ */
